'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * @desc 将图片、文本等绘制到canvas上，以供用户下载保存
 *  <CreatePic config={[
        {
            image: require('static/images/1.png'),
            x: 10,
            y: 10
        },{
            image: require('static/images/3.png'),
            x: 160,
            y: 10,
            width: 100,
            height:100,
            round: false,
            composite: 'source-over'
        },
        {
            text: `火影忍者，尾兽拥有无穷无尽的查克拉和战斗力，被称为“凶暴的神”`,
            x: 50,
            y: 200,
            align: 'right',
            width: 500,
            height: 70,
            color:'red',
            lineHeight: 30,
            font: '20px Helvetica'
        }
    ]} width={600} height={1200} background="grey" />
 *
 */
var CreatePic = (_temp2 = _class = function (_Component) {
    _inherits(CreatePic, _Component);

    function CreatePic() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, CreatePic);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CreatePic.__proto__ || Object.getPrototypeOf(CreatePic)).call.apply(_ref, [this].concat(args))), _this), _this.state = { img: null, loading: true, error: null }, _this.create = function () {
            var _this$props = _this.props,
                config = _this$props.config,
                width = _this$props.width,
                height = _this$props.height,
                background = _this$props.background;


            if (background) {
                _this.ctx.fillStyle = background;
                _this.ctx.fillRect(0, 0, width, height);
            }

            return config.reduce(function (chain, item) {
                return chain.then(function () {
                    return new Promise(function (resolve, reject) {
                        if (item.image) {
                            var img = new Image();

                            if (/^http/i.test(item.image) || item.crossOrigin) {
                                img.crossOrigin = item.crossOrigin || 'anonymous';
                            }

                            img.onload = function () {
                                _this.ctx.globalCompositeOperation = item.composite || 'source-over';

                                _this.drawImage({
                                    img: img,
                                    x: item.x,
                                    y: item.y,
                                    width: item.width,
                                    height: item.height,
                                    round: item.round
                                });

                                resolve();
                            };

                            img.onerror = function () {
                                console.log(item.image + ' 图片加载失败!');
                                reject(new Error('Failed to load ' + item.image));
                            };

                            img.src = item.image;
                        }

                        if (item.text) {
                            _this.ctx.globalCompositeOperation = item.composite || 'source-over';
                            _this.drawText(item);
                            resolve();
                        }
                    });
                });
            }, Promise.resolve());
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(CreatePic, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            this.canvas = document.createElement('canvas');
            this.ctx = this.canvas.getContext('2d');
            this.canvas.width = this.props.width;
            this.canvas.height = this.props.height;

            this.create().then(function () {
                var img = _this2.canvas.toDataURL('image/jpeg', 0.7);

                _this2.setState({
                    img: img
                }, function () {
                    _this2.props.onload && _this2.props.onload(img);
                });
            }).catch(function (error) {
                _this2.setState({
                    error: error
                }, function () {
                    _this2.props.onerror && _this2.props.onerror(error);
                });
            }).then(function () {
                return _this2.setState({
                    loading: false
                });
            });
        }
    }, {
        key: 'drawImage',


        /**
         * @desc 绘制图片
         * @param {Image} img 图片对象
         * @param {Number} [x] 绘制起始横坐标
         * @param {Number} [y] 绘制起始纵坐标
         * @param {Number} [width] 图片缩放宽度
         * @param {Number} [height] 图片缩放高度
         * @param {string} [composite] 图片组合蒙层类型，取值同globalCompositeOperation
         * @param {Boolean} [round] 图片是否带圆角
         */
        value: function drawImage(_ref2) {
            var img = _ref2.img,
                _ref2$y = _ref2.y,
                y = _ref2$y === undefined ? 0 : _ref2$y,
                _ref2$x = _ref2.x,
                x = _ref2$x === undefined ? 0 : _ref2$x,
                _ref2$width = _ref2.width,
                width = _ref2$width === undefined ? 0 : _ref2$width,
                _ref2$height = _ref2.height,
                height = _ref2$height === undefined ? 0 : _ref2$height,
                _ref2$round = _ref2.round,
                round = _ref2$round === undefined ? false : _ref2$round;

            this.ctx.save();

            if (round) {
                this.ctx.fill();
                this.ctx.beginPath();
                this.ctx.arc(x + width / 2, y + height / 2, Math.min(width, height) / 2, 0, 2 * Math.PI);
                this.ctx.closePath();
                this.ctx.clip();
            }

            this.ctx.drawImage(img, x, y, width, height);
            this.ctx.restore();
        }

        /**
         * @desc 绘制文本，支持多行绘制，支持换行符
         * @param {object} item 要绘制的文本对象，有以下属性：
         *              text 文本字符串
         *              font 绘制的字体样式，同css里的font字端
         *              width 绘制的最大宽幅，如果省略，则默认绘制到canvas边缘换行
         *              lineHeight 行高，省略则会等于字体宽度的1.4
         *              color 字体颜色
         *              align 对齐方向，可选值 left、center、right
         *              x 开始横坐标
         *              y 开始纵坐标
         */

    }, {
        key: 'drawText',
        value: function drawText(item) {
            var ctx = this.ctx;

            ctx.font = item.font || '30px arial';
            ctx.fillStyle = item.color;

            var maxWidth = item.width || this.props.width - item.x;
            var lineHeight = item.lineHeight || ctx.measureText('热').width * 1.4;

            var curLine = 0,
                // 当前绘制行
            curIndex = 0,
                // 要绘制的字符串索引
            curDrawWidth = 0; // 当前行已绘制宽度

            for (var i = curIndex; i < item.text.length; i++) {
                // 支持省略号最后的行数
                var isEllipsisLine = item.height > 0 && Math.floor(item.height / lineHeight) === curLine + 1;

                if (item.text[i] === '\n') {
                    // 遇到换行符，主动换行

                    var currentText = item.text.substring(curIndex, i);
                    var text = isEllipsisLine ? this.getEllipsisText(currentText, maxWidth) : currentText;

                    ctx.fillText(text, this.countX(item.align, item.x, curDrawWidth, maxWidth), item.y + lineHeight * curLine);

                    curIndex = i;
                    curLine++;
                    curDrawWidth = 0;

                    if (isEllipsisLine) {
                        break;
                    }
                } else {
                    var curCharWidth = ctx.measureText(item.text[i]).width;

                    // 判断是否需要换行
                    if (curDrawWidth + curCharWidth > maxWidth) {
                        var _findWord = this.findWord(item.text, i),
                            findWordStart = _findWord.index,
                            offset = _findWord.offset;

                        // 英文单词等不要分割


                        if (findWordStart >= curIndex && this.isWordLetter(item.text[i])) {
                            var _currentText = item.text.substring(curIndex, findWordStart + 1);
                            var _text = isEllipsisLine ? this.getEllipsisText(_currentText, maxWidth) : _currentText;

                            ctx.fillText(_text, this.countX(item.align, item.x, curDrawWidth - offset, maxWidth), item.y + lineHeight * curLine);

                            curIndex = findWordStart + 1;
                            curDrawWidth = offset;

                            if (isEllipsisLine) {
                                break;
                            }
                        } else {
                            var _currentText2 = item.text.substring(curIndex, i);
                            var _text2 = isEllipsisLine ? this.getEllipsisText(_currentText2, maxWidth) : _currentText2;

                            ctx.fillText(_text2, this.countX(item.align, item.x, curDrawWidth, maxWidth), item.y + lineHeight * curLine);

                            curIndex = i;
                            curDrawWidth = curCharWidth;

                            if (isEllipsisLine) {
                                break;
                            }
                        }

                        curLine++;
                    } else if (i + 1 === item.text.length) {
                        // 绘制最后一行
                        ctx.fillText(item.text.substring(curIndex), this.countX(item.align, item.x, curDrawWidth + curCharWidth, maxWidth), item.y + lineHeight * curLine);
                    } else {
                        // 累加字符渲染宽度
                        curDrawWidth += curCharWidth;
                    }
                }
            }
        }

        // 添加省略号

    }, {
        key: 'getEllipsisText',
        value: function getEllipsisText(text, maxWidth) {
            var ellipsisWidth = this.ctx.measureText('...').width;
            var textWidth = this.ctx.measureText(text).width;

            while (text.length > 0 && textWidth + ellipsisWidth > maxWidth) {
                text = text.substring(0, text.length - 1);
                textWidth = this.ctx.measureText(text).width;
            }

            return text + '...';
        }
    }, {
        key: 'findWord',
        value: function findWord(text, index) {
            var offset = 0;

            while (index-- || index === 0) {
                if (!this.isWordLetter(text[index])) {
                    return {
                        index: index,
                        offset: offset
                    };
                }

                offset += this.ctx.measureText(text[index]).width;
            }
        }
    }, {
        key: 'isWordLetter',
        value: function isWordLetter(char) {
            var charCode = char.charCodeAt(0);

            return charCode >= 33 && charCode <= 126;
        }
    }, {
        key: 'countX',
        value: function countX(type, x, width, maxWidth) {
            switch (type) {
                case 'center':
                    return x + maxWidth / 2 - width / 2;
                case 'right':
                    return x + maxWidth - width;
                default:
                    return x;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _state = this.state,
                img = _state.img,
                error = _state.error,
                loading = _state.loading;
            var children = this.props.children;


            if (typeof children === 'function') {
                return children({
                    state: loading ? 0 : error ? 2 : 1,
                    img: img,
                    error: error,
                    loading: loading
                });
            }

            if (loading) {
                return children;
            }

            if (img) {
                return _react2.default.createElement('img', { src: img, alt: 'create pic output', className: 'create-pic-output' });
            }

            return null;
        }
    }]);

    return CreatePic;
}(_react.Component), _class.propTypes = {
    config: _propTypes2.default.array.isRequired,
    width: _propTypes2.default.number.isRequired,
    height: _propTypes2.default.number.isRequired,
    background: _propTypes2.default.string,
    onload: _propTypes2.default.func,
    onerror: _propTypes2.default.func
}, _temp2);
exports.default = CreatePic;